var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

import _JSXStyle from 'styled-jsx/style';

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';

import { camelCaseToWords } from '../utils.js';

var Options = function (_Component) {
	_inherits(Options, _Component);

	function Options() {
		_classCallCheck(this, Options);

		var _this = _possibleConstructorReturn(this, (Options.__proto__ || Object.getPrototypeOf(Options)).call(this));

		_this.handleOptionChange = _this.handleOptionChange.bind(_this);
		_this.toggleOption = _this.toggleOption.bind(_this);
		return _this;
	}

	_createClass(Options, [{
		key: 'render',
		value: function render() {
			var _this2 = this;

			var options = ['showCalendarNames', 'showLocations'];

			var params = new URLSearchParams(location.search);

			var inputs = options.map(function (option) {
				return React.createElement(
					'label',
					{ key: option },
					React.createElement('input', { type: 'checkbox', value: option,
						checked: params.has(option),
						onChange: _this2.handleOptionChange }),
					camelCaseToWords(option)
				);
			});

			return React.createElement(
				'div',
				{
					'data-jsx': 1250369456
				},
				inputs,
				React.createElement(_JSXStyle, {
					styleId: 1250369456,
					css: 'div[data-jsx="1250369456"] { display:-webkit-box; display:-ms-flexbox; display:flex;-moz-flex-direction: row;-webkit-box-orient: horizontal;-webkit-box-direction: normal;-ms-flex-direction: row;flex-direction: row;-ms-flex-wrap: wrap;flex-wrap: wrap;-ms-flex-pack: distribute;justify-content: space-around;}'
				})
			);
		}
	}, {
		key: 'handleOptionChange',
		value: function handleOptionChange(event) {
			var option = event.target.value;
			this.toggleOption(option);
		}
	}, {
		key: 'toggleOption',
		value: function toggleOption(option) {
			var _props = this.props,
			    location = _props.location,
			    history = _props.history;

			var params = new URLSearchParams(location.search);
			if (params.has(option)) params.delete(option);else params.append(option, true);

			var newLocation = Object.assign({}, location, { search: '?' + params.toString() });
			history.push(newLocation);
		}
	}]);

	return Options;
}(Component);

export default Options;


Options.propTypes = {
	location: PropTypes.shape({
		search: PropTypes.string
	}),
	history: PropTypes.shape({
		push: PropTypes.func.isRequired
	})
};